--- /etc/rc.d/jail	2009-11-29 14:57:51.903840488 +0100
+++ jail	2009-11-29 16:28:50.471354236 +0100
@@ -302,14 +302,17 @@
 		fi
 	fi
 	if checkyesno _mount; then
-		[ -f "${_fstab}" ] || warn "${_fstab} does not exist"
-		tail -r ${_fstab} | while read _device _mountpt _rest; do
-			case ":${_device}" in
-			:#* | :)
-				continue
-				;;
-			esac
-			secure_umount ${_mountpt}
+		for _fstab_file in ${_fstab}; do
+			[ -f "${_fstab_file}" ] || warn "${_fstab_file} does not exist"
+			sed "s#ROOT#${_rootdir}#" ${_fstab_file} |
+			    tail -r | while read _device _mountpt _rest; do
+				case ":${_device}" in
+				:#* | :)
+					continue
+					;;
+				esac
+				secure_umount ${_mountpt}
+			done
 		done
 	fi
 }
@@ -327,7 +330,8 @@
 #
 jail_mount_fstab()
 {
-	local _device _mountpt _rest
+	local _fstab_file _device _mountpt _rest
+	_fstab_file="$*"
 
 	while read _device _mountpt _rest; do
 		case ":${_device}" in
@@ -335,12 +339,17 @@
 			continue
 			;;
 		esac
-		if is_symlinked_mountpoint ${_mountpt}; then
-			warn "${_mountpt} has symlink as parent - not mounting from ${_fstab}"
+		if [ ${_mountpt%%/*} = "ROOT" ]; then
+			if is_symlinked_mountpoint "${_rootdir}/${_mountpt#*/}"; then
+				warn "${_rootdir}/${_mountpt#*/} has symlink as parent - not mounting from ${_fstab_file}"
+				return
+			fi
+		elif is_symlinked_mountpoint ${_mountpt}; then
+			warn "${_mountpt} has symlink as parent - not mounting from ${_fstab_file}"
 			return
 		fi
-	done <${_fstab}
-	mount -a -F "${_fstab}"
+	done <${_fstab_file}
+	sed "s#ROOT#${_rootdir}#" ${_fstab_file} | mount -a -F /dev/stdin
 }
 
 # jail_show_addresses jail
@@ -575,10 +584,12 @@
 		fi
 		if checkyesno _mount; then
 			info "Mounting fstab for jail ${_jail} (${_fstab})"
-			if [ ! -f "${_fstab}" ]; then
-				err 3 "$name: ${_fstab} does not exist"
-			fi
-			jail_mount_fstab
+			for _fstab_file in ${_fstab}; do
+				if [ ! -f "${_fstab_file}" ]; then
+					err 3 "$name: ${_fstab_file} does not exist"
+				fi
+				jail_mount_fstab ${_fstab_file}
+			done
 		fi
 		if checkyesno _devfs; then
 			# If devfs is already mounted here, skip it.
